/*
 *  neoCMMDef.h
 *  
 *
 *  Created by Carles on 24/05/08.
 *  Copyright 2008 Indit Software. All rights reserved.
 *
 */

#pragma once

#ifndef _NEO_CMM_DEF_H_
#define _NEO_CMM_DEF_H_

#ifdef _MSC_VER
#else
#endif

#define neoCMMHPROFILE void *
#define neoCMMHTRANSFORM void *
#define neoCMMHLRU void *

// Mxim n' de canals
#define neoCMM_MAX_CHANNELS				32
#define neoCMM_MAX_PERFILS_TRANS  8


// Motors de color
#define neoCMM_ENGINE_LCMS			0
#define neoCMM_ENGINE_ADOBE			1
#define neoCMM_ENGINE_NATIVE		2
#define neoCMM_ENGINE_MAX			neoCMM_ENGINE_NATIVE
#define neoCMM_ENGINE_DEFAULT		neoCMM_ENGINE_LCMS
#define neoCMM_ENGINE_INVALID		-1
#define neoCMM_ENGINE_ANY			9999

// Render Intents per a conversions
#define neoCMM_RENDER_PERCEPTUAL						0
#define neoCMM_RENDER_SATURATION						1
#define neoCMM_RENDER_RELATIVE_COLORIMETRIC	2
#define neoCMM_RENDER_ABSOLUTE_COLORIMETRIC	3
#define neoCMM_RENDER_MATCHING							4

// Color spaces 
#define neoCMM_CS_RGB		0
#define neoCMM_CS_GRAY	1
#define neoCMM_CS_LAB		2
#define neoCMM_CS_BGR		3
#define neoCMM_CS_CMYK	4
#define neoCMM_CS_NCHA5	5
#define neoCMM_CS_NCHA6	6
#define neoCMM_CS_NCHA7	7
#define neoCMM_CS_NCHA8	8
#define neoCMM_CS_HSB		9
#define neoCMM_CS_HSL		10
#define neoCMM_CS_XYZ		11
#define neoCMM_CS_LCH		12


typedef enum
{ 
		undef, 
		gray, gray_8, gray_16, 
		bgr, bgr_8, bgr_16,
		rgb, rgb_8, rgb_16,
		cmyk, cmyk_8, cmyk_16, 
		cmyk5, cmyk5_8, cmyk5_16,
		cmyk6, cmyk6_8, cmyk6_16,
		cmyk7, cmyk7_8, cmyk7_16,
		cmyk8, cmyk8_8, cmyk8_16,
		lab, lab_8, lab_16, labQ, labS,
		hsb, hsb_8, hsb_16,
		hsl, hsl_8, hsl_16,
		lch, lch_8,
		xyz
} neoCMM_typeFormatColor;

// standard profiles
#define neoCMM_STDPROFILE_LAB							0
// #define neoCMM_STDPROFILE_LAB_D65			1
#define neoCMM_STDPROFILE_sRGB						2
#define neoCMM_STDPROFILE_GRAY						3
#define neoCMM_STDPROFILE_ProPhotoRGB			4
#define neoCMM_STDPROFILE_sRGBnoBPC				5
#define neoCMM_STDPROFILE_AdobeRGB1998		6
#define neoCMM_STDPROFILE_EuroscaleCoated	7
#define neoCMM_STDPROFILE_MAX							8	// Nota: Actualizar 

#define neoCMM_STR_STDPROFILE_sRGB							"@sRGB"
#define neoCMM_STR_STDPROFILE_sRGBnoBPC					"@sRGBnoBPC"
#define neoCMM_STR_STDPROFILE_LAB								"@CIELAB"
#define neoCMM_STR_STDPROFILE_GRAY							"@GRAY"
#define neoCMM_STR_STDPROFILE_ProPhotoRGB				"@ProPhotoRGB"
#define neoCMM_STR_STDPROFILE_AdobeRGB1998			"@AdobeRGB1998"
#define neoCMM_STR_STDPROFILE_EuroscaleCoated 	"@EuroscaleCoated"

// flags per a la conversio
#define neoCMM_F_BLACKPOINTCOMPENSATION		1
#define neoCMM_F_WHITEPOINTPROOF					2
#define neoCMM_F_BLACKPOINTPROOF					4
//#define neoCMM_F_HIRESPRECALC							8		// LCMS only (DEPRECATED)
//#define neoCMM_F_LORESPRECALC							16	// LCMS only (DEPRECATED)
#define neoCMM_F_DRAFTCONVERSION					32	
#define neoCMM_F_NORMALCONVERSION					64	
#define neoCMM_F_HQCONVERSION							128	
#define neoCMM_F_GAMUTCHECK								256
#define neoCMM_F_FROMDLL									512 // indica a NColorTrans que el crea la api de la DLL
#define neoCMM_F_IGNOREFORCEDENGINE				1024

// 
#define neoCMM_CHECKSUM_NOTCACHE				0xFFFFFFFF

// Tags d'informacio
#define neoCMM_NCOMPONENTS_TAG_INT			0
#define neoCMM_COLORSPACE_TAG_INT				1
#define neoCMM_BUFFERSIZE_TAG_ULONG			2
#define neoCMM_BUFFERDATA_TAG_PTR				3
#define neoCMM_ILLUMINANT_TAG_INT				4
#define neoCMM_ILLUMINANTXYZ_TAG_XYZ		5
#define neoCMM_WHITEPOINT_TAG_XYZ				6  // XYZ is defined as float[3];
#define neoCMM_BLACKPOINT_TAG_XYZ				7
#define neoCMM_NAME_TAG_STRING					8
#define neoCMM_TYPE_TAG_INT							9
#define neoCMM_PATH_TAG_STRING					10
#define neoCMM_CIED_TAG_STRING					11 // string buffer with the measurements

// Iluminants 
//		CAUTION: don't change these values !!
#define neoCMM_IL_UNKNOWN	-1
#define neoCMM_IL_A		0
#define neoCMM_IL_B		1
#define neoCMM_IL_C		2
#define neoCMM_IL_D50	3
#define neoCMM_IL_D55	4
#define neoCMM_IL_D65	5
#define neoCMM_IL_D75	6
#define neoCMM_IL_E		7
#define neoCMM_IL_F2		8
#define neoCMM_IL_F7		9
#define neoCMM_IL_F11	10
#define neoCMM_IL_CUSTOM	11

#define neoCMM_N_ILUMINANTS   (neoCMM_IL_CUSTOM+1)

#define neoCMM_OBS_2		 2
#define neoCMM_OBS_10		10

#define NEOCMM_F_ENUM_TYPE_ANY				0x00FF0000
#define NEOCMM_F_ENUM_TYPE_INPUT			0x00010000
#define NEOCMM_F_ENUM_TYPE_DISPLAY		0x00020000
#define NEOCMM_F_ENUM_TYPE_OUTPUT			0x00040000
#define NEOCMM_F_ENUM_TYPE_LINK				0x00080000
#define NEOCMM_F_ENUM_TYPE_ABSTRACT		0x00100000
#define NEOCMM_F_ENUM_TYPE_COLORSPACE	0x00200000
#define NEOCMM_F_ENUM_TYPE_NAMEDCOLOR	0x00400000

// XML 
#define neoCMM_KEY_PROFILES	"Profiles"
#define neoCMM_KEY_PROFILE	"Profile"
#define neoCMM_KEY_NAME			"name"
#define neoCMM_KEY_PATH			"path"
#define neoCMM_KEY_SPACE		"space"
#define neoCMM_KEY_TYPE			"type"
#define neoCMM_KEY_ENGINE		"engine"

#define neoCMM_KEY_RGB			"RGB"
#define neoCMM_KEY_GRAY			"GRAY"
#define neoCMM_KEY_LAB			"LAB"
#define neoCMM_KEY_BGR			"BGR"
#define neoCMM_KEY_CMYK			"CMYK"
#define neoCMM_KEY_NCHA5		"NCHA5"
#define neoCMM_KEY_NCHA6		"NCHA6"
#define neoCMM_KEY_NCHA7		"NCHA7"
#define neoCMM_KEY_NCHA8		"NCHA8"
#define neoCMM_KEY_HSB			"HSB"
#define neoCMM_KEY_HSL			"HSL"
#define neoCMM_KEY_XYZ			"XYZ"
#define neoCMM_KEY_LCH			"LCH"
#define neoCMM_KEY_UNKNOW		"UNKNOW"

#pragma warning (disable: 4305)

static float g_neoCMM_il_array[][3] = {
	{1.0985, 1.0000, 0.3558}, //A
	{0.9907, 1.0000, 0.8522}, //B
	{0.9807, 1.0000, 1.1823}, //C
	{0.9642, 1.0000, 0.8249}, //D50
	{0.9568, 1.0000, 0.9215}, //D55
	{0.9505, 1.0000, 1.0891}, //D65
	{0.9497, 1.0000, 1.2264}, //D75
	{1.0000, 1.0000, 1.0000}, //E
	{0.9919, 1.0000, 0.6739}, //F2
	{0.9504, 1.0000, 1.0875}, //F7
	{1.0096, 1.0000, 0.6435}  //F11
};

#endif	/*_NEO_CMM_DEF_H_*/
